#ifndef GPIBLIB_H
#define GPIBLIB_H

#include "typedefs.h"

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef BUILDING_GPIBLIB
   #define GPIBDEF __declspec(dllexport)
#else
   #define GPIBDEF __declspec(dllimport)
#endif

typedef void (WINAPI *GPIBERR)      (C8 *msg, S32 ibsta, S32 iberr, S32 ibcntl);
typedef S32  (WINAPI *SRPROGRESSCB) (void);
                                                  
GPIBDEF S32    WINAPI GPIB_connect                 (S32        device_address, 
                                                    GPIBERR    handler, 
                                                    S32        clear                  = 0, 
                                                    S32        timeout_msecs          = 100000,
                                                    S32        board_address          = -1, 
                                                    S32        release_system_control = 0,
                                                    S32        max_read_buffer_len    = 4096);   // >4K will not work with NI GPIB-232!

GPIBDEF S32          WINAPI GPIB_disconnect                        (BOOL32 reset_to_local = TRUE);
GPIBDEF S32          WINAPI GPIB_set_EOS_mode                      (S32 new_EOS_char, BOOL32 send_EOI_at_EOT = TRUE, BOOL32 enable_board_configuration = TRUE);
GPIBDEF S32          WINAPI GPIB_write                             (C8 *string, S32 len=-1, BOOL32 to_board = FALSE, BOOL32 ignore_aborts = TRUE); 
GPIBDEF S32          WINAPI GPIB_write_BIN                         (void *string, S32 len, BOOL32 to_board = FALSE, BOOL32 ignore_aborts = TRUE); 
GPIBDEF S32          WINAPI GPIB_set_serial_read_timeout           (S32 ms); 
GPIBDEF SRPROGRESSCB WINAPI GPIB_set_serial_read_progress_callback (SRPROGRESSCB progress_callback = NULL); 
GPIBDEF C8 *         WINAPI GPIB_serial_configuration              (S32 *controller_mode = NULL, S32 *device_addressable = NULL, S32 *host_addressable = NULL);
GPIBDEF C8 *         WINAPI GPIB_read_ASC                          (S32 max_len=-1, BOOL32 report_timeout = TRUE, BOOL32 from_board = FALSE);
GPIBDEF C8 *         WINAPI GPIB_read_BIN                          (S32 max_len=-1, BOOL32 report_timeout = TRUE, BOOL32 from_board = FALSE, S32 *actual_len = NULL);
GPIBDEF S32          WINAPI GPIB_status                            (BOOL32 from_board = FALSE);
GPIBDEF C8 *         WINAPI GPIB_query                             (C8 *string);
GPIBDEF C8           WINAPI GPIB_serial_poll                       (void);
GPIBDEF S32          WINAPI GPIB_flush_receive_buffers             (void);
                                                                   
#ifdef __cplusplus
}
#endif

#endif
